import {
  select,
  json,
  tsv,
  geoPath,
  geoNaturalEarth1,
  zoom,
  event
} from 'd3';
import { feature } from 'topojson';

const svg = select('svg');

const projection = geoNaturalEarth1();
const pathGenerator = geoPath().projection(projection);

const g = svg.append('g');

let selectedCountry;

g.append('path')
    .attr('class', 'sphere')
    .attr('d', pathGenerator({type: 'Sphere'}));

svg.call(zoom().on('zoom', () => {
  g.attr('transform', event.transform);
}));


const onClick = id => {
  selectedCountry = id;
//  console.log({selectedCountry})
  render();
};

const render = () => {
    onClick, 
    selectedCountry
};
    
render();

Promise.all([
  tsv('https://unpkg.com/world-atlas@1.1.4/world/50m.tsv'),
  json('https://unpkg.com/world-atlas@1.1.4/world/50m.json')
]).then(([tsvData, topoJSONdata]) => {
 
  
  const countryName = tsvData.reduce((accumulator, d) => {
    accumulator[d.iso_n3] = d.name;
    return accumulator;
  }, {});
  
 
  const countries = feature(
    topoJSONdata, 
    topoJSONdata.objects.countries, 
    onClick, 
    selectedCountry
  );
   
  g.selectAll('path').data(countries.features)
    .enter().append('path')
      .attr('class', 'country')
      .attr('d', pathGenerator)
    .append('title')
      .text(d => countryName[d.id])
  
  const paths = g.selectAll('path').data(countries.features);
  
  console.log(selectedCountry)
  
  paths
    .enter().append('path')
      .attr('class', 'country')
      .attr('d', pathGenerator)
    .append('title')
      .text(d => countryName[d.id])
    .merge(paths)
      .attr('fill', d =>
        d.id === selectedCountry
          ? 'red'
          : 'lightgreen'
      )
      .on('click', d => {
      console.log(selectedCountry)
      });
});

